package com.jkcredit.query.record.filter;

import com.jkcredit.query.record.service.TokenService;
import org.apache.catalina.connector.RequestFacade;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author xusonglin
 * @version V1.0
 **/
@WebFilter(urlPatterns = "/*", filterName = "requestCheckFilter")
@Order(value = 1)
@Component
public class RequestCheckFilter implements Filter {
    @Autowired
    TokenService tokenService;

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        System.out.println(234);
        if (((RequestFacade) servletRequest).getRequestURI().equals("/token")) {
            filterChain.doFilter(servletRequest, servletResponse);
        } else {
            HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;
            String token = httpServletRequest.getHeader("token");
            if (StringUtils.isBlank(token)) {
                // token不存在
                servletRequest.getRequestDispatcher("/tokenNotExist").forward(servletRequest,servletResponse);
            } else {
                // 验证token
                boolean validateResult = tokenService.validateToken(token);
                if (!validateResult) {
                    servletRequest.getRequestDispatcher("/tokenError").forward(servletRequest,servletResponse);
                } else {
                    filterChain.doFilter(servletRequest, servletResponse);
                }
            }
        }
    }
}
